package sun.java2d.pipe;

import java.awt.Rectangle;
import java.awt.geom.PathIterator;
import sun.awt.geom.PathConsumer2D;

public final class ShapeSpanIterator implements SpanIterator, PathConsumer2D
{
    long pData;
    
    public static native void initIDs();
    
    public ShapeSpanIterator(boolean normalize) {
        this.setNormalize(normalize);
    }
    
    public void appendPath(PathIterator pathIterator) {
        float[] array = new float[6];
        this.setRule(pathIterator.getWindingRule());
        while (!pathIterator.isDone()) {
            this.addSegment(pathIterator.currentSegment(array), array);
            pathIterator.next();
        }
        this.pathDone();
    }
    
    public native void appendPoly(int[] p0, int[] p1, int p2, int p3, int p4);
    
    private native void setNormalize(boolean p0);
    
    public void setOutputAreaXYWH(int n, int n2, int n3, int n4) {
        this.setOutputAreaXYXY(n, n2, Region.dimAdd(n, n3), Region.dimAdd(n2, n4));
    }
    
    public native void setOutputAreaXYXY(int p0, int p1, int p2, int p3);
    
    public void setOutputArea(Rectangle rectangle) {
        this.setOutputAreaXYWH(rectangle.x, rectangle.y, rectangle.width, rectangle.height);
    }
    
    public void setOutputArea(Region region) {
        this.setOutputAreaXYXY(region.lox, region.loy, region.hix, region.hiy);
    }
    
    public native void setRule(int p0);
    
    public native void addSegment(int p0, float[] p1);
    
    @Override
    public native void getPathBox(int[] p0);
    
    @Override
    public native void intersectClipBox(int p0, int p1, int p2, int p3);
    
    @Override
    public native boolean nextSpan(int[] p0);
    
    @Override
    public native void skipDownTo(int p0);
    
    @Override
    public native long getNativeIterator();
    
    public native void dispose();
    
    @Override
    public native void moveTo(float p0, float p1);
    
    @Override
    public native void lineTo(float p0, float p1);
    
    @Override
    public native void quadTo(float p0, float p1, float p2, float p3);
    
    @Override
    public native void curveTo(float p0, float p1, float p2, float p3, float p4, float p5);
    
    @Override
    public native void closePath();
    
    @Override
    public native void pathDone();
    
    @Override
    public native long getNativeConsumer();
    
    static {
        initIDs();
    }
}
